<div class="sub-page-container">
  <!-- Title -->
  <h1>{{ 'parameter.economics.title' | translate }}</h1>
  <mat-divider></mat-divider>

  <div class="sub-page-body" *ngIf="economics | async; let ecom">
    <div class="left-container" *ngIf="$schema | async; let schema">
      <div class="grid">
        <!-- 
          Costs for Project Management 
        -->
        <div class="grid-item costs-for-project-management">
          <div class="title">
            <h2>{{ 'parameter.economics.projManagmCost' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.economics.projManagmCostDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <!-- $any als temporary fix, ersetzen falls bessere Lösung -->
          <energy-platform-parameter-slider
            #projManagmCost
            [unit]="schema.economics.properties.project_management_cost.unit"
            [min]="schema.economics.properties.project_management_cost.minimum"
            [max]="schema.economics.properties.project_management_cost.maximum"
            [step]="schema.economics.properties.project_management_cost.step"
            [formControl]="$any(sliderFormGroup).controls.projManagmCost"
            name="projManagmCostSlider"
            (valueChange)="ecom.project_management_cost = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Costs for Substation
         -->
        <div class="grid-item cost-for-substation">
          <div class="title">
            <h2>{{ 'parameter.economics.substCost' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.economics.substCostDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #substCost
            [unit]="schema.economics.properties.cost_per_substation.unit"
            [min]="schema.economics.properties.cost_per_substation.minimum"
            [max]="schema.economics.properties.cost_per_substation.maximum"
            [step]="schema.economics.properties.cost_per_substation.step"
            [formControl]="$any(sliderFormGroup).controls.substCost"
            name="substCostSlider "
            (valueChange)="ecom.cost_per_substation = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Costs for Wind Turbine
         -->
        <div class="grid-item cost-for-wind-turbine">
          <div class="title">
            <h2>{{ 'parameter.economics.costPerTurb' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.economics.costPerTurbDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #costPerTurb
            [unit]="schema.economics.properties.cost_per_turbine.unit"
            [min]="schema.economics.properties.cost_per_turbine.minimum"
            [max]="schema.economics.properties.cost_per_turbine.maximum"
            [step]="schema.economics.properties.cost_per_turbine.step"
            [formControl]="$any(sliderFormGroup).controls.costPerTurb"
            name="costPerTurbSlider "
            (valueChange)="ecom.cost_per_turbine = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Cost for Wind Turbine Foundation
         -->
        <div class="grid-item cost-for-wind-turbine-foundation">
          <div class="title">
            <h2>{{ 'parameter.economics.costPerTurbFound' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.economics.costPerTurbFoundDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <mat-radio-group
            class="radio-container"
            disableOptionCentering
            value="1"
          >
            <mat-radio-button value="1" #auto>
              {{
                'parameter.economics.automaticComputationwithBathymetry'
                  | translate
              }}
            </mat-radio-button>
            <mat-radio-button value="2"
              >{{ 'parameter.economics.manual' | translate }}
            </mat-radio-button>
          </mat-radio-group>

          <ng-container *ngIf="!auto.checked">
            <energy-platform-parameter-slider
              #matSlider_economics_costPerTurbineFoundation
              class="option_slider"
              color="primary"
              [unit]="
                schema.economics.properties.cost_per_turbine_foundation.unit
              "
              [min]="
                schema.economics.properties.cost_per_turbine_foundation.minimum
              "
              [max]="
                schema.economics.properties.cost_per_turbine_foundation.maximum
              "
              [step]="
                schema.economics.properties.cost_per_turbine_foundation.step
              "
              [value]="ecom.cost_per_turbine_foundation"
              (valueChange)="ecom.cost_per_turbine_foundation = $event"
            >
            </energy-platform-parameter-slider>

            <!-- <div class="option_slider_minmax">
              <div class="option_slider_minmax_wrapper">
                <span>{{
                  numberWithCommas(
                    matSlider_economics_costPerTurbineFoundation.min
                  )
                }}</span>
              </div>
              <div class="option_slider_minmax_wrapper">
                <span>{{
                  numberWithCommas(
                    matSlider_economics_costPerTurbineFoundation.max
                  )
                }}</span>
              </div>
            </div> -->
          </ng-container>
        </div>
        <!-- 
          Costs for Laying Cables
         -->
        <div class="grid-item cost-for-laying-cables">
          <div class="title">
            <h2>{{ 'parameter.economics.costPerCablLen' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.economics.costPerCablLenDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #costPerCablLen
            [unit]="
              schema.economics.properties.cable_laying_cost_per_cable_length
                .unit
            "
            [min]="
              schema.economics.properties.cable_laying_cost_per_cable_length
                .minimum
            "
            [max]="
              schema.economics.properties.cable_laying_cost_per_cable_length
                .maximum
            "
            [step]="
              schema.economics.properties.cable_laying_cost_per_cable_length
                .step
            "
            [formControl]="$any(sliderFormGroup).controls.costPerCablLen"
            name="costPerCablLenSlider"
            (valueChange)="ecom.cable_laying_cost_per_cable_length = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Costs for Annual Operation and Maintenance per Installed MW 
        -->
        <div class="grid-item cost-for-maintenance">
          <div class="title">
            <h2>{{ 'parameter.economics.annualOACost' | translate }}</h2>
          </div>
          <energy-platform-parameter-slider
            #annualOACost
            [unit]="schema.economics.properties.cost_per_operation.unit"
            [min]="schema.economics.properties.cost_per_operation.minimum"
            [max]="schema.economics.properties.cost_per_operation.maximum"
            [step]="schema.economics.properties.cost_per_operation.step"
            [formControl]="$any(sliderFormGroup).controls.annualOACost"
            name="annualOACostSlider"
            (valueChange)="ecom.cost_per_operation = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Project Lifetime
         -->
        <div class="grid-item project-lifetime">
          <div class="title">
            <h2>{{ 'parameter.economics.projLifetime' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.economics.projLifetimeDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #projLifetime
            [unit]="schema.economics.properties.project_lifetime.unit"
            [min]="schema.economics.properties.project_lifetime.minimum"
            [max]="schema.economics.properties.project_lifetime.maximum"
            [step]="schema.economics.properties.project_lifetime.step"
            [value]="ecom.project_lifetime"
            (valueChange)="ecom.project_lifetime = $event"
          ></energy-platform-parameter-slider>
        </div>
        <!-- 
          Effective Interest Rate
         -->
        <div class="grid-item effective-interest-rate">
          <div class="title">
            <h2>{{ 'parameter.economics.discountRate' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.economics.discountRateDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
          </div>
          <energy-platform-parameter-slider
            #discountRate
            [unit]="schema.economics.properties.interest_rate.unit"
            [min]="schema.economics.properties.interest_rate.minimum"
            [max]="schema.economics.properties.interest_rate.maximum"
            [step]="schema.economics.properties.interest_rate.step"
            [value]="ecom.interest_rate"
            (valueChange)="ecom.interest_rate = $event"
          ></energy-platform-parameter-slider>
        </div>
      </div>
      <!--
        Save Button
      -->
      <button
        mat-button
        class="pill-button save-button"
        [disabled]="
          !buttonValidator([
            ecom.cost_per_turbine,
            ecom.cost_per_substation,
            ecom.cable_laying_cost_per_cable_length,
            ecom.project_management_cost,
            ecom.cost_per_operation,
            ecom.project_lifetime,
            ecom.interest_rate
          ])
        "
        (click)="onSave()"
      >
        {{ 'parameter.general.save' | translate }}
      </button>
    </div>

    <div class="right-container">
      <div class="grid">
        <!--
          Energy Tariff
        -->
        <div
          class="grid-item energy-tariff"
          *ngIf="$schema | async; let schema"
        >
          <div class="title">
            <h2>{{ 'parameter.economics.energyPriceTarif' | translate }}</h2>
            <mat-icon
              [matTooltip]="
                'parameter.economics.energyPriceTarifDescription' | translate
              "
              matTooltipPosition="right"
            >
              info_outlined
            </mat-icon>
            <mat-error *ngIf="errorValueOutOfBounds" class="error">
              <mat-icon>{{ 'warning' }}</mat-icon>
              <p>
                {{ 'error.economics.valueOutOfBounds' | translate }}
              </p>
            </mat-error>
            <mat-error *ngIf="errorInvalidValue" class="error">
              <mat-icon>{{ 'warning' }}</mat-icon>
              <p>
                {{ 'error.economics.invalidValue' | translate }}
              </p>
            </mat-error>
          </div>
          <div class="body">
            <table>
              <tbody>
                <tr>
                  <td
                    *ngFor="
                      let slot of ecom.energy_price_tariff;
                      let index = index;
                      trackBy: trackByFn
                    "
                  >
                    <!-- TODO value update is delayed by one valueChange call -->
                    <mat-form-field>
                      <input
                        matInput
                        value="{{ getInputValue(index) }}"
                        (input)="onChange($event, index)"
                        [min]="
                          schema.economics.properties.energy_price_tariff.items
                            .minimum
                        "
                        [max]="
                          schema.economics.properties.energy_price_tariff.items
                            .maximum
                        "
                      />
                    </mat-form-field>
                  </td>
                </tr>
              </tbody>
            </table>
            <ngx-charts-line-chart
              class="chart"
              [results]="priceTarifChartData"
              [xAxis]="true"
              [yAxis]="true"
              [showXAxisLabel]="true"
              [showYAxisLabel]="true"
              [xAxisLabel]="xAxisLabel"
              [yAxisLabel]="yAxisLabel"
              [xAxisTicks]="xAxisTicks"
              [curve]="curve"
            >
            </ngx-charts-line-chart>
          </div>
        </div>
        <!--
          Bar Chart
        -->
        <div class="grid-item bar-chart">
          <energy-platform-stacked-bar-chart
            yAxisLabel="{{ 'parameter.economics.barChartYAxis' | translate }}"
            [values]="chartData$ | async"
          ></energy-platform-stacked-bar-chart>
        </div>
      </div>
    </div>
  </div>
</div>
